> ## Documentation Index
> Fetch the complete documentation index at: https://docs.firedrill.run/llms.txt
> Use this file to discover all available pages before exploring further.

# Read a bounded page of namespaced world state



## OpenAPI

````yaml /api-reference/openapi.json get /v1/projects/{projectId}/sessions/{sessionId}/state
openapi: 3.1.0
info:
  title: Firedrill Control API
  version: 1.0.0
  description: >-
    The control plane for drills, drill runs, and the worlds they run in. Errors
    always carry the canonical envelope; unsafe operations require an
    Idempotency-Key; long work returns an operation resource.
servers:
  - url: https://api.firedrill.run
security:
  - controlCredential: []
paths:
  /v1/projects/{projectId}/sessions/{sessionId}/state:
    get:
      summary: Read a bounded page of namespaced world state
      operationId: sessions.state
      parameters:
        - name: projectId
          in: path
          required: true
          schema:
            type: string
            pattern: ^prj_[0-9a-z]{12,32}$
        - name: sessionId
          in: path
          required: true
          schema:
            type: string
            pattern: ^ses_[0-9a-z]{12,32}$
        - name: packageId
          in: query
          required: true
          schema:
            type: string
            minLength: 1
            maxLength: 96
        - name: namespace
          in: query
          required: true
          schema:
            type: string
            minLength: 1
            maxLength: 96
        - name: afterRowId
          in: query
          required: false
          schema:
            type: string
            minLength: 1
            maxLength: 512
        - name: limit
          in: query
          required: false
          schema:
            default: 100
            type: integer
            minimum: 1
            maximum: 200
      responses:
        '200':
          description: World state page
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WorldStatePage'
        default:
          description: Canonical error envelope
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
components:
  schemas:
    WorldStatePage:
      type: object
      properties:
        schemaVersion:
          type: number
          enum:
            - 1
        sessionId:
          type: string
          pattern: ^ses_[0-9a-z]{12,32}$
        packageId:
          type: string
          minLength: 1
          maxLength: 96
          pattern: ^[a-z][a-z0-9]*(?:[-_][a-z0-9]+)*$
        instanceId:
          type: string
          minLength: 1
          maxLength: 96
          pattern: ^[a-z][a-z0-9]*(?:[-_][a-z0-9]+)*$
        namespace:
          type: string
          minLength: 1
          maxLength: 96
          pattern: ^[a-z][a-z0-9]*(?:[-_][a-z0-9]+)*$
        items:
          maxItems: 200
          type: array
          items:
            type: object
            properties:
              packageId:
                type: string
                minLength: 1
                maxLength: 96
                pattern: ^[a-z][a-z0-9]*(?:[-_][a-z0-9]+)*$
              instanceId:
                type: string
                minLength: 1
                maxLength: 96
                pattern: ^[a-z][a-z0-9]*(?:[-_][a-z0-9]+)*$
              namespace:
                type: string
                minLength: 1
                maxLength: 96
                pattern: ^[a-z][a-z0-9]*(?:[-_][a-z0-9]+)*$
              rowId:
                type: string
                minLength: 1
                maxLength: 512
              value:
                type: object
                additionalProperties:
                  $ref: '#/components/schemas/WorldStatePage___schema0'
            required:
              - packageId
              - namespace
              - rowId
              - value
            additionalProperties: false
        nextRowId:
          type: string
          minLength: 1
          maxLength: 512
      required:
        - schemaVersion
        - sessionId
        - packageId
        - namespace
        - items
      additionalProperties: false
    ErrorEnvelope:
      type: object
      properties:
        code:
          type: string
          pattern: ^(control|world)\.[A-Z][A-Z0-9]*(_[A-Z0-9]+)*$
        message:
          type: string
          minLength: 1
        correlationId:
          type: string
          minLength: 1
        retryable:
          type: boolean
        retryAfterMs:
          type: integer
          exclusiveMinimum: 0
          maximum: 9007199254740991
        operationId:
          type: string
        source:
          type: string
          enum:
            - platform
            - simulated_provider
        issues:
          type: array
          items:
            type: object
            properties:
              path:
                type: string
              code:
                type: string
              message:
                type: string
            required:
              - path
              - code
              - message
            additionalProperties: false
        details:
          type: object
          propertyNames:
            type: string
          additionalProperties: {}
        evidence:
          type: object
          properties:
            sessionId:
              type: string
            runId:
              type: string
            journalSeq:
              type: integer
              minimum: 0
              maximum: 9007199254740991
            buildHash:
              type: string
          additionalProperties: false
      required:
        - code
        - message
        - correlationId
        - retryable
        - source
      additionalProperties: true
    WorldStatePage___schema0:
      description: Any JSON-compatible value
  securitySchemes:
    controlCredential:
      type: http
      scheme: bearer
      description: Opaque control credential

````